package proj.zoie.service.api;

/**
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import java.io.Serializable;

public class SearchResult implements Serializable {

  /**
   * 
   */
  private static final long serialVersionUID = 1L;

  private int totalHits;
  private int totalDocs;
  private long time;

  public SearchResult() {

  }

  private SearchHit[] hits;

  public int getTotalHits() {
    return totalHits;
  }

  public void setTotalHits(int totalHits) {
    this.totalHits = totalHits;
  }

  public int getTotalDocs() {
    return totalDocs;
  }

  public void setTotalDocs(int totalDocs) {
    this.totalDocs = totalDocs;
  }

  public long getTime() {
    return time;
  }

  public void setTime(long time) {
    this.time = time;
  }

  public SearchHit[] getHits() {
    return hits;
  }

  public void setHits(SearchHit[] hits) {
    this.hits = hits;
  }

}
